#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include <string>
#ifdef HAVE_GL_GL_H
#  include <GL/gl.h>
#elif HAVE_OPENGL_GL_H
#  include <OpenGL/gl.h>
#endif
#ifdef HAVE_GL_GLU_H
#  include <GL/glu.h>
#elif HAVE_OPENGL_GLU_H
#  include <OpenGL/glu.h>
#endif
#include "height_quantity.hh"
#include "sww_file.hh"

using std::string;

HeightQuantity::HeightQuantity(const SWWFile &sww, const string &name,
			       GLdouble offset, GLdouble scale,
			       GLfloat red, GLfloat green, GLfloat blue):
  offset(offset), scale(scale), red(red), green(green), blue(blue), name(name),
  frame_number(-1), sww(sww){
  GLenum glerror;
  this->dynamic = (sww.nc_inq_varndims_by_name(name) == 2);
  this->display_list = glGenLists(1);
  if((glerror = glGetError()) != GL_NO_ERROR) throw gluErrorString(glerror);
  
}

HeightQuantity::~HeightQuantity(void){
  if(glIsList(this->display_list) == GL_TRUE)
    glDeleteLists(this->display_list, 1);
}

void HeightQuantity::draw(int frame){
  if(!this->dynamic) frame = 0;
  if(this->frame_number != frame) this->compile(frame);
  this->frame_number = frame;
  glPushMatrix();
  glScalef(1, 1, this->scale);
  glTranslatef(0, 0, this->offset);
  glColor3f(this->red, this->green, this->blue);
  glCallList(this->display_list);
  glPopMatrix();
}

void HeightQuantity::compile(int frame){
  
}
