#ifndef HEIGHT_QUANTITY_HH
#define HEIGHT_QUANTITY_HH

/* An individual height quantity to render. */

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include <string>

#ifdef HAVE_GL_GL_H
#  include <GL/gl.h>
#elif HAVE_OPENGL_GL_H
#  include <OpenGL/gl.h>
#endif
#include "sww_file.hh"

using std::string;

class HeightQuantity {
public:
  HeightQuantity(const SWWFile &sww, const string &name,
		 const GLdouble offset, GLdouble scale,
		 GLfloat red, GLfloat green, GLfloat blue);
  ~HeightQuantity(void);
  void draw(int frame);
  GLdouble offset;
  GLdouble scale;
  GLfloat red;
  GLfloat green;
  GLfloat blue;
private:
  void compile(int frame);
  string name;
  int frame_number; /* The most recently drawn frame (i.e., the one
		       cached in the display list. */
  bool dynamic;
  GLuint display_list;
  const SWWFile &sww;
};

#endif
